////////////////////////////////////////////////////////////////////
// VfBK[̐lvZASY
////////////////////////////////////////////////////////////////////
#define _USE_MATH_DEFINES
#include <math.h>
#include <stdlib.h>
#include <time.h>
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <cstdio>
#include <iomanip>
#include <stdio.h>
#include <complex>
#include <omp.h>
#include <direct.h>

/////////////////////////////////////////////////////////////////
//萔
/////////////////////////////////////////////////////////////////
//
const double c = 2.99792458E+8;
//^̓
const double mu0 = 4.0*M_PI*1.0E-7;
//^̗Ud
const double epsilon0 = 1.0 / (4.0*M_PI*c*c)*1.0E+7;
//vN萔
const double h = 6.6260896 * 1.0E-34;
double hbar = h / (2.0*M_PI);
//dq̎
const double me = 9.10938215 * 1.0E-31;
//dq{g
const double eV = 1.60217733 * 1.0E-19;
//f
const std::complex<double> I = std::complex<double>(0.0, 1.0);
/////////////////////////////////////////////////////////////////
//n̐ݒ
/////////////////////////////////////////////////////////////////
//Ԃ̑傫
const int Lz = 5000, Ld = 10;
//ԕTCY
double dz = 1.0E-11;
//dˍ킹̐
const int Npulse = 200;
//pX̕
double delta_z = 0.5E-8;
double sigma = 2.0*sqrt(2.0*log(2.0)) / (delta_z);
//g̊Ԋu
double dk = 30.0 / (delta_z * double(Npulse + 1));
//ž_̏ꏊ
const int iz0 = Lz / 2 - Lz / 10;
//dqg̃GlM[
const double E0 = 0.0 * eV;
//g̒S
double k0 = sqrt(2.0 * me * E0 / pow(hbar, 2));
//pU̒S
double omega0 = hbar / (2.0*me) * pow(k0, 2);

//|eV
double V1 = 0.0 * eV;
double V2 = 0.0 * eV;
double V3 = 0.0 * eV;

//ʎq˂̕
double d = 0 * dz;

//ԊԊu
double dt = 1.0 * 1.0E-16;

//|eV
double V(double x) {
	if (x < 0) return V1;
	else if (x < d) return V2;
	else return V3;

}

/////////////////////////////////////////////////////////////////
//t[Gϊ
/////////////////////////////////////////////////////////////////
void FFT(double* an, double* bn, int N, bool Inverse) {
	/////////////////////////////////////////
	// 
	// N  F i2ׂ̂j
	// an : ziϊFԃf[^NŎwAtϊFWJWa(n)j
	// bn : ziϊFԃf[^NŎwAtϊFWJWb(n)j
	// Inverse : tϊ̏ꍇ true
	/////////////////////////////////////////
	// o
	// an : ziϊFWJWa(n)AtϊFԃf[^j
	// bn : ziϊFWJWb(n)AtϊFԃf[^j
	/////////////////////////////////////////

	int ff = Inverse ? 1 : -1;

	int* rot = new int[N];

	for (int i = 0; i < N; i++) rot[i] = 0;

	int nhalf = N / 2, num = N / 2;
	double sc = 2.0 * M_PI / N;

	while (num >= 1) {
		for (int j = 0; j < N; j += 2 * num) {
			int phi = rot[j] / 2;
			int phi0 = phi + nhalf;
			double c = cos(sc * phi);
			double s = sin(sc * phi * ff);
			for (int k = j; k < j + num; k++) {
				int k1 = k + num;
				double a0 = an[k1] * c - bn[k1] * s;
				double b0 = an[k1] * s + bn[k1] * c;
				an[k1] = an[k] - a0;
				bn[k1] = bn[k] - b0;
				an[k] = an[k] + a0;
				bn[k] = bn[k] + b0;
				rot[k] = phi;
				rot[k1] = phi0;
			}
		}
		num = num / 2;
	}

	for (int i = 0; i < N; i++) {
		int j = rot[i];
		if (j > i) {
			double tmp = an[i];
			an[i] = an[j];
			an[j] = tmp;
			tmp = bn[i];
			bn[i] = bn[j];
			bn[j] = tmp;
		}
	}
	if (!Inverse) {
		for (int i = 0; i < N; i++) {
			an[i] = an[i] / N;
			bn[i] = bn[i] / N;
		}
	}
	delete[] rot;
}



class RK4 {
private:
public:
	//vpeB
	double dt = 0.01; //ԊԊu
	int N;
	double L;
	std::complex<double>* an, *a1n, *a2n, *a3n, *a4n, *_a1n, *_a2n, *_a3n, *_a4n;
	std::complex<double>* dan;
	std::complex<double>* vn;
	//RXgN^
	RK4() {}
	RK4(double _N, double _dt, double _L) {
		N = _N;
		L = _L;
		dt = _dt;
		an = new std::complex<double>[N];
		a1n = new std::complex<double>[N];
		a2n = new std::complex<double>[N];
		a3n = new std::complex<double>[N];
		a4n = new std::complex<double>[N];
		_a1n = new std::complex<double>[N];
		_a2n = new std::complex<double>[N];
		_a3n = new std::complex<double>[N];
		_a4n = new std::complex<double>[N];
		dan = new std::complex<double>[N];
		vn = new std::complex<double>[N];
	}
	//fBXgN^
	~RK4() {
		delete[] an, a1n, a2n, a3n, a4n, dan;
		delete[] vn;
	}
	//xxNg^郁\bh
	void V(double t, std::complex<double> *an, std::complex<double> *out_vs) {

		#pragma omp parallel for
		for (int n = 0; n < N; n++){

			std::complex<double> kn;

			if (n < N / 2) {
				kn = 2.0 * M_PI / L * n;
			}
			else {
				kn = -2.0 * M_PI / L * (N - n);
			}

			out_vs[n] = hbar * kn * kn / (2.0 * me * I)* an[n];

			for (int l = 0; l < N; l++) {
				if (n >= l) {
					int m = n - l;
					out_vs[n] += vn[l] / (I * hbar) * an[m];
				}
				else {
					int m = N - (l - n);
					out_vs[n] += vn[l] / (I * hbar) * an[m];
				}
			}
		}
	}
	//ԔWvZ郁\bh
	void timeEvolution(double t) {
		//Pi
		V(t, an, a1n);

		for (int i = 0; i < N; i++) {
			_a1n[i] = an[i] + a1n[i] * dt / 2.0;
		}
		//Qi
		V(t + dt / 2.0, _a1n, a2n);
		for (int i = 0; i < N; i++) {
			_a2n[i] = an[i] + a2n[i] * dt / 2.0;
		}
		//Ri
		V(t + dt / 2.0, _a2n, a3n);
		for (int i = 0; i < N; i++) {
			_a3n[i] = an[i] + a3n[i] * dt;
		}
		//Si
		V(t + dt, _a3n, a4n);
		for (int i = 0; i < N; i++) {
			dan[i] = dt / 6.0 * (a1n[i] + 2.0 * a2n[i] + 2.0 * a3n[i] + a4n[i]);
		}
	}
};

/////////////////////////////////////////////////////////////////
std::string folder = "output";//쐬tH_
const int precision_N = 4;
std::string filepath1 = folder + "/error-16_1024.txt";
std::string filepath2 = folder + "/pulse-16.txt";


int main() {

	//tH_
	_mkdir(folder.c_str());

	//ԁEgԂ̕
	const int N = 1024;

	//ñTCYinj
	double L = 2.0 * M_PI / dk;

	//ϊp
	double vn_real[N], vn_imag[N];
	double an_real[N], an_imag[N];

	//|eVǂ
	for (int n = 0; n < N; n++) {
		double x = L / N * n;
		vn_real[n] = V(x);
		vn_imag[n] = 0;
	}
	//ϊ̎s
	FFT(vn_real, vn_imag, N, false); //vn_real, vn_imag Ƀt[Gϊ̌Wi[

	 //g̏ʒu
	double x0 = 0;// L / 2.0;//2000*dz;

	//QENb^@pIuWFNg
	RK4 rk4(N, dt, L);

	for (int n = 0; n < N; n++) {

		double kn = 2.0 * M_PI / L * (n - N / 2);
		if (n < N / 2) {
			kn = 2.0 * M_PI / L * n;
		}
		else {
			kn = -2.0 * M_PI / L * (N - n);
		}
		rk4.an[n] = exp(-I * kn * x0) * exp(-1.0 / 2.0 * pow((kn - k0) / sigma, 2));
		rk4.vn[n] = std::complex<double>(vn_real[n], vn_imag[n]);
	}

	//tϊp
	double _vn_real[N], _vn_imag[N];
	double _an_real[N], _an_imag[N];




	//o̓Xg[ɂt@CI[v
	std::ofstream fout1;
	fout1.open(filepath1.c_str());
	fout1 << "#x:" << std::endl;
	fout1 << "#y:vZ덷" << std::endl;
	fout1 << "#showLines: false false" << std::endl;
	fout1 << "#showMarkers: true true" << std::endl;
	fout1 << "#fills: false false" << std::endl;
	fout1 << "#set logscale y" << std::endl;
	//o̓Xg[ɂt@CI[v
	std::ofstream fout2;
	fout2.open(filepath2.c_str());
	fout2 << "#x:ʒu" << std::endl;
	fout2 << "#y:mU" << std::endl;
	fout2 << "#legend:   Βl" << std::endl;
	fout2 << "#showLines: true true true true false false" << std::endl;
	fout2 << "#showMarkers: false false false false true true" << std::endl;
	fout2 << "#fills: false false false false" << std::endl;
//	fout2 << "#xrange:" << -Lz / 2 << " " << Lz / 2 << " " << Lz / 10 << std::endl;
	fout2 << "#yrange:" << -0.4 << " " << 1 << " " << 0.1 << std::endl;

	for (int tn = 0; tn <= 20000; tn++) {
		double t = dt * tn;
		std::cout << tn << std::endl;

		//o
		if (tn % 100 == 0) {
			fout2 << "#coma:" << tn << std::endl;

			for (int n = 0; n < N; n++) {
				_vn_real[n] = vn_real[n];
				_vn_imag[n] = vn_imag[n];
				_an_real[n] = rk4.an[n].real();
				_an_imag[n] = rk4.an[n].imag();
			}

			//tϊ̎s
			FFT(_vn_real, _vn_imag, N, true);
			FFT(_an_real, _an_imag, N, true);

			double error = 0;
			for (int n = 0; n < N; n++) {

				double x = L / N * n;
				if (n < N / 2) {
					x = L / N * n;
				}
				else {
					x = -L / N * (N - n);
				}

				std::complex<double> Psi = std::complex<double>(0.0, 0.0);

				for (int m = 0; m < N; m++) {

					double kn;

					if (m < N / 2) {
						kn = 2.0 * M_PI / L * m;
					}
					else {
						kn = -2.0 * M_PI / L * (N - m);
					}
					double omega = hbar / (2.0 * me) * pow(kn, 2);
					Psi += exp(I * kn * x) * exp(-I * omega * t) * exp(-1.0 / 2.0 * pow((kn - k0) / sigma, 2));

				}
				error += abs( abs(Psi) - sqrt(_an_real[n] * _an_real[n] + _an_imag[n] * _an_imag[n]) );

				fout2 << x / dz << " " << _an_real[n]/40.0 << " " << _an_imag[n]/ 40.0 <<  " " << sqrt(_an_real[n] * _an_real[n] + _an_imag[n] * _an_imag[n]) / 40.0 << std::endl;

			}
			fout2 << std::endl;

			fout1 << tn << " " << error / N << std::endl;

		}

		//QENb^@ɂ鎞ԔW
		rk4.timeEvolution(t);

		for (int n = 0; n < N; n++) {
			//ʒu̍XV
			rk4.an[n] = rk4.an[n] + rk4.dan[n];
		}

	}

	fout1.close();
	fout2.close();

}

/*
gccRpC
g++ main.cpp
*/